﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using PAT.Common.Classes.Expressions.ExpressionClass;

namespace PAT.Lib
{
    class Disk : DeviceBase
    {
        //two ports. 0 for address, 1 for data
        Concat content = new Concat();

        Value _adr = new Value(0);     //address register
        //GDBase _data = Value.Error();    //R1: data register

        public Disk()
        {

        }

        public Disk(Disk obj)
        {
            content = (Concat)obj.content.clone();
            _adr = (Value)obj._adr.clone();
        }

        public Disk(Concat disk)
        {
            content = (Concat)disk.clone();
        }


        public override string ToString()
        {
            return ExpressionID;
        }

        public override ExpressionValue GetClone()
        {
            return clone();
        }

        public override DeviceBase clone()
        {
            return new Disk(this);
        }

        public override string ExpressionID
        {
            get
            {
                string ret = " DISK adr=" + _adr + "\n";
                for (int i = 0; i < content.size; i++)
                {
                    ret += " [" + i + "]:" + content.component(i).ToString();
                    if ((i + 1) % 4 == 0 && i != content.size - 1) ret += "\n";
                }
                return ret;
            }
        }

        public override GDBase read(int offset)
        {
            if (offset == 0)
            {
                return _adr.clone();
            }
            else if (offset == 1)
            {
                if (!_adr.isError && _adr.v >= 0 && _adr.v < content.size)
                {
                    return content.component(_adr.v);
                }
                else
                    throw new SysError();
                    //return Value.Error();
            }
            else
            {
                throw new PAT.Common.Classes.Expressions.ExpressionClass.RuntimeException("disk: invalid device port");
            }
        }

        public override void write(int offset, GDBase gd)
        {
            if (offset == 0)
            {
                if (gd is Value && !((Value)gd).isError)
                {
                    _adr = (Value)gd.clone();
                }
                else
                {
                    throw new SysError();
                    //_adr = Value.Error();
                }
                
            }
            else if (offset == 1)
            {
                if (!_adr.isError&&_adr.v >= 0 && _adr.v < content.size)
                {
                    content.list[_adr.v] = gd.clone();
                }
                else
                {
                    throw new SysError();
                    //_adr = Value.Error();
                }
            }
            else
            {
                throw new PAT.Common.Classes.Expressions.ExpressionClass.RuntimeException("disk: invalid device port");
            }
            
        }

        public override int size()
        {
            return 2;
        }

        public override void reset()
        {
            _adr = new Value(0);
        }

        public int len()
        {
            return content.size;
        }
    }
}
