﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using PAT.Common.Classes.Expressions.ExpressionClass;

namespace PAT.Lib
{
    class NetworkAdapter : DeviceBase
    {
        //one port for bi-directional communication

        int _chnTransmit = -1;
        int _chnReceive = -1;

        public NetworkAdapter()
        {

        }

        public NetworkAdapter(NetworkAdapter obj)
        {
            _chnTransmit = obj._chnTransmit;
            _chnReceive = obj._chnReceive;
        }

        public NetworkAdapter(int transmit, int receive)
        {
            _chnTransmit = transmit;
            _chnReceive = receive;
        }


        public override string ToString()
        {
            return ExpressionID;
        }

        public override ExpressionValue GetClone()
        {
            return clone();
        }

        public override DeviceBase clone()
        {
            return new NetworkAdapter(this);
        }

        public override string ExpressionID
        {
            get
            {
                string ret = " NET Transmit=" + _chnTransmit + " Receive=" + _chnReceive + "\n";
                return ret;
            }
        }

        public override GDBase read(int offset)
        {
            if (offset == 0)
            {
                if (_chnReceive != -1)
                {
                    throw SyncException.syncChannelInput(_chnReceive);
                }
                else
                    throw new PAT.Common.Classes.Expressions.ExpressionClass.RuntimeException("net: receive channel not ready");
            }
            else
            {
                throw new PAT.Common.Classes.Expressions.ExpressionClass.RuntimeException("net: invalid device port");
            }
        }

        public override void write(int offset, GDBase gd)
        {
            if (offset == 0)
            {
                if (_chnTransmit != -1)
                {
                    throw SyncException.syncChannelOutput(_chnTransmit, gd);
                }
                else
                    throw new PAT.Common.Classes.Expressions.ExpressionClass.RuntimeException("net: transmit channel not ready");
            }
            else
            {
                throw new PAT.Common.Classes.Expressions.ExpressionClass.RuntimeException("net: invalid device port");
            }
        }

        public override int size()
        {
            return 1;
        }

        public override void reset()
        {
            //
        }
    }
}
