﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using PAT.Common.Classes.Expressions.ExpressionClass;
namespace PAT.Lib
{
    class RAM : DeviceBase
    {
        Concat _data = new Concat();


        public RAM()
        {
        }

        public RAM(RAM obj)
        {
            _data = (Concat)obj._data.clone();
        }

        public RAM(int n)
        {
            _data = new Concat();
            for (int i = 0; i < n; i++)
            {
                _data.joinWithoutClone(new Value(0));
            }
        }

        public override GDBase read(int offset)
        {
            if (offset >= 0 && offset < _data.size)
            {
                return _data.component(offset);
            }
            else
                throw new PAT.Common.Classes.Expressions.ExpressionClass.RuntimeException("mem: invalid device port");
        }

        public override void write(int offset, GDBase gd)
        {
            if (offset >= 0 && offset < _data.size)
            {
                _data.list[offset] = gd.clone();
            }
            else
                throw new PAT.Common.Classes.Expressions.ExpressionClass.RuntimeException("mem: invalid device port");
        }

        public override int size()
        {
            if (_data == null)
                return 0;
            else
                return _data.size;
        }

        public override void reset()
        {
            for (int i = 0; i < size(); i++)
            {
                _data.list[i] = new Value(0);
            }
        }

        public override string ToString()
        {
            if (_data != null)
            {
                string ret = " RAM";
                //bool first = true;
                for (int i = 0; i < _data.size; i++)
                {
                    if (_data.component(i) is Value && !((Value)_data.component(i)).isError && ((Value)_data.component(i)).v == 0) continue;
                    ret += "\n";
                    ret += " [" + i + "]:" + _data.component(i).ToString();
                    //if ((i + 1) % 4 == 0 && i != _data.size - 1) ret += "\n";
                    //first = false;
                }
                return ret;
            }
            else
                return "";
        }

        public override ExpressionValue GetClone()
        {
            return clone();
        }

        public override DeviceBase clone()
        {
            return new RAM(this);
        }

        public override string ExpressionID
        {
            get
            {
                if (_data != null)
                    return _data.ExpressionID;
                else
                    return "";
            }
        }
    }
}
