﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using PAT.Common.Classes.Expressions.ExpressionClass;
namespace PAT.Lib
{
    class ROM : DeviceBase
    {
        GDBase _data = new Value(0);


        public ROM()
        {
        }

        public ROM(ROM obj)
        {
            _data = obj._data.clone();
        }

        public ROM(GDBase __data)
        {
            _data = __data.clone();
        }

        public override GDBase read(int offset)
        {
            if (offset ==0)
            {
                return _data;
            }
            else
                throw new PAT.Common.Classes.Expressions.ExpressionClass.RuntimeException("rom: invalid device port");
        }

        public override void write(int offset, GDBase gd)
        {
            if (offset==0)
            {
                throw new SysError();
                //throw new PAT.Common.Classes.Expressions.ExpressionClass.RuntimeException("rom: cannot be written");
            }
            else
                throw new PAT.Common.Classes.Expressions.ExpressionClass.RuntimeException("rom: invalid device port");
        }

        public override int size()
        {
            return 1;
        }

        public override void reset()
        {

        }

        public override string ToString()
        {
            if (_data != null)
            {
                string ret = " ROM: "+_data.ToString();
                return ret;
            }
            else
                return "";
        }

        public override ExpressionValue GetClone()
        {
            return clone();
        }

        public override DeviceBase clone()
        {
            return new ROM(this);
        }

        public override string ExpressionID
        {
            get
            {
                if (_data != null)
                    return _data.ExpressionID;
                else
                    return "";
            }
        }
    }
}
