﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using PAT.Common.Classes.Expressions.ExpressionClass;

namespace PAT.Lib
{
    class PCR : Hash
    {
        public PCR()
        {
            plaintext = Value.Error();
        }

        public PCR(PCR obj)
        {
            if (obj._plaintext != null)
            {
                _plaintext = obj._plaintext.clone();
            }
        }

        public PCR(GDBase value)
        {
            plaintext = value;
        }

        public override ExpressionValue GetClone()
        {
            return clone();
        }

        public override GDBase clone()
        {
            return new PCR(this);
        }


        private string stylePCR(GDBase obj)
        {
            string ret = "";
            if (obj is Concat)
            {
                Concat c = (Concat)obj;
                if (c.size == 2 && c.component(0) is PCR)
                {
                    ret = stylePCR(((PCR)c.component(0)).plaintext) + "->" + c.component(1).ToString();
                }
                else
                {
                    ret = c.ToString();
                }
            }
            else
            {
                ret = obj.ToString();
            }
            return ret;
        }

        public override string ToString()
        {
            string ret;
            ret = "pcr(" + stylePCR(plaintext) + ")";
            return ret;
        }

        public void extend(GDBase newdata)
        {
            plaintext = new Concat(new PCR(plaintext), newdata.clone());
        }
    }
}
