﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using PAT.Common.Classes.Expressions.ExpressionClass;

namespace PAT.Lib
{
    class Hash : GDBase
    {

        protected GDBase _plaintext = new Value(0);


        public GDBase plaintext
        {
            get { return _plaintext; }
            set { _plaintext = value; }
        }


        public Hash()
        {
        }

        public Hash(Hash obj)
        {
            _plaintext = obj._plaintext.clone();
        }

        public Hash(GDBase value)
        {
            plaintext = value;
        }

        public override ExpressionValue GetClone()
        {
            return clone();
        }

        public override GDBase clone()
        {
            return new Hash(this);
        }


        
        public override string ToString()
        {
            string ret;
            ret = "hash(" + plaintext.ToString() + ")";
            return ret;
        }

        public override string ExpressionID
        {
            get
            {
                return "hash(" + plaintext.ExpressionID + ")";
            }
        }

        public override string typeString()
        {
            return "hash(" + plaintext.typeString() + ")";
        }

        public override List<GDBase> generate(List<GDBase> k)
        {
            List<GDBase> ret = base.generate(k);
            List<GDBase> content = plaintext.generate(k);

            foreach (GDBase gdb in content)
            {
                ret.Add(new Hash(gdb));
            }
            return ret;
        }

        public override bool duplicate(List<GDBase> k)
        {
            bool ret = false;
            ret |= base.duplicate(k);
            ret |= plaintext.duplicate(k);
            return ret;
        }
    }
}
