﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using PAT.Common.Classes.Expressions.ExpressionClass;
namespace PAT.Lib
{
    partial class Computer : ExpressionValue
    {


        //GD
        public bool isProg(GDBase value)
        {
            return value is Prog;
        }

        public bool isError(GDBase value)
        {
            bool ret = false;
            if (value is Value)
            {
                ret = ((Value)value).isError;
            }
            return ret;
        }

        public int getv(Value value)
        {
            return value.v;
        }

        public int getAKeyID(AKey akey)
        {
            return akey.id;
        }

        public GDBase getComponent(GDBase data, int i)
        {
            if (data is Concat)
                return ((Concat)data).component(i);
            else if (data is XOR)
                return ((XOR)data).component(i);
            else
                return Value.Error();
        }

        public GDBase getPlaintext(Signature sign)
        {
            return sign.plaintext;
        }

        public GDBase getXOR(GDBase data1, GDBase data2)
        {
            XOR ret = new XOR();
            if (data1 is XOR)
            {
                foreach (GDBase e in ((XOR)data1).list)
                {
                    ret.join(e);
                }
            }
            else
            {
                ret.join(data1);
            }
            if (data2 is XOR)
            {
                foreach (GDBase e in ((XOR)data2).list)
                {
                    ret.join(e);
                }
            }
            else
            {
                ret.join(data2);
            }
            if (ret.size == 1)
                return ret.list[0];
            else
                return ret;
        }

    }


}
